module doodle.dia.page_layer;

public {
    import doodle.dia.icanvas;
}

private {
    import doodle.tk.cairo;
}

class PageLayer : Layer, IPage {
    this(in string name = "Page") {
        super(name);
        _pageGeometry = Rectangle(Point.DEFAULT, Vector(210.0, 297.0));
        //_pageGeometry = Rectangle(Point.DEFAULT, Vector(100.0, 100.0));
    }

    // Layer overrides:

    override Rectangle bounds() const {
        return _pageGeometry;
    }

    override void draw(in Rectangle screenDamage, scope Drawable screenDrawable,
                       in Rectangle modelDamage, scope Drawable modelDrawable) const {
        // Make the paper white, with a border

        modelDrawable.pushState; {
            modelDrawable.setColor(Color(0.0, 0.0, 0.0, 1.0));
            modelDrawable.drawRectangle(_pageGeometry, false);
        } modelDrawable.popState;

        modelDrawable.pushState; {
            modelDrawable.setColor(Color(1.0, 1.0, 1.0, 1.0));
            modelDrawable.drawRectangle(_pageGeometry, true);
        } modelDrawable.popState;
    }

    // IPage overrides:

    private {
        Rectangle _pageGeometry;
    }
}
